/****************************************************
Between Ground and Clouds - Differences and Similarities in DB Backend implementation

Dmitri Korotkevitch
http://aboutsqlserver.com

Share-Nothing approach in Windows Azure SQL Database Federations

RUN IN CONTEXT OF AZURE DB

*****************************************************/


-- Creating table in ROOT db

create table dbo.TableInMain
(
	ID int not null primary key,
	Val char(255)
)
go

insert into dbo.TableInMain(ID,Val)
values(1,'Table in Main Root DB')
go

select * from dbo.TableInMain
go




-- Creating Federation
create federation Fed(FID int range)
go

alter federation Fed split at (fid = 100)
go



-- Switching to Federation DB

use federation Fed(fid=0) with reset, filtering=off
go

select * from dbo.TableInMain
go

create table dbo.FedTable
(
	ID int not null primary key,
	Val char(255)
)
federated on (fid=id)
go

insert into dbo.FedTable(ID,Val)
values(1,'Federated table')
go

insert into dbo.FedTable(ID,Val)
values(300,'Incorrect range')
go

select * from dbo.FedTable
go


-- Switching to another Federation

use federation Fed(fid=200) with reset, filtering=off
go

select * from dbo.FedTable
go

create table dbo.FedTable
(
	ID int not null primary key,
	Val char(255)
)
federated on (fid=id)
go

insert into dbo.FedTable(ID,Val)
values(300,'Another val')
go

select * from dbo.FedTable
go


-- Switching to ROOT
use federation root with reset
go

select * from dbo.FedTable
go

select * from dbo.TableInMain
go
